{00}

unit xx00main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

const
  MaxN = 11;
  DelkaSirky = 40;
  KlikTolerance = 5;  {pocet pixelu, kde muze hrac kliknou mimo sirku a prece se to zapocita jako kerektni klik}
  Barvy: array[0..4] of TColor = (clSilver, clBlue, clRed, clBlue, clRed);
  Vertikalne = 0;
  Horizontalne = 1;

type
  TMainForm = class(TForm)
    PaintBox: TPaintBox;
    StartButton: TButton;
    Label1: TLabel;
    PlayerBox: TPanel;
    Hrac1Label: TLabel;
    Hrac2Label: TLabel;
    Label4: TLabel;
    Hrac1Body: TEdit;
    Hrac2Body: TEdit;
    TopTenButton: TButton;
    HintButton: TButton;
    procedure PaintBoxPaint(Sender: TObject);
    procedure PaintBoxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure StartButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TopTenButtonClick(Sender: TObject);
    procedure HintButtonClick(Sender: TObject);
  private
    { Private declarations }
    N: Byte;
    Horiz: array[0..MaxN+1, 0..MaxN+1] of Byte;
    HorizC: array[0..MaxN+1, 0..MaxN+1] of Boolean;
    Vert: array[0..MaxN+1, 0..MaxN+1] of Byte;
    VertC: array[0..MaxN+1, 0..MaxN+1] of Boolean;    
    AktHrac: Byte;  {aktualni hrac}
    Player: array[1..2] of record
      Jmeno: string;
      Clovek: Boolean;
    end;
    KlavX, KlavY: Byte;
    HintX, HintY: Byte;
    HintHoriz: Boolean;
    procedure ZmenaHrace;
    procedure PolozenaSirka(hv, sy, sx: Byte);
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

uses xx00start, xx00topten;

{$R *.DFM}

procedure TMainForm.PaintBoxPaint(Sender: TObject);
var y, x: Word;
begin
  with Sender as TPaintBox do
  begin
    Canvas.FillRect(Rect(0, 0, Width, Height));
    {horizontalni}
    for y:=1 to N do
      for x:=1 to N-1 do
      begin
        if HorizC[y, x] then Canvas.Pen.Width:=2 else Canvas.Pen.Width:=1;
        Canvas.Pen.Color:=Barvy[Horiz[y, x]];
        if (HintHoriz) and (HintY=y) and (HintX=x) then
        begin
          Canvas.Pen.Color:=clTeal;
          Canvas.Pen.Width:=2
        end;  
        Canvas.MoveTo(x*DelkaSirky, y*DelkaSirky);
        Canvas.LineTo((x+1)*DelkaSirky, y*DelkaSirky);
      end;
    {vertikalni}
    for y:=1 to N-1 do
      for x:=1 to N do
      begin
        if VertC[y, x] then Canvas.Pen.Width:=2 else Canvas.Pen.Width:=1;
        Canvas.Pen.Color:=Barvy[Vert[y, x]];
        if (not HintHoriz) and (HintY=y) and (HintX=x) then
        begin
          Canvas.Pen.Color:=clTeal;
          Canvas.Pen.Width:=2
        end;  
        Canvas.MoveTo(x*DelkaSirky, y*DelkaSirky);
        Canvas.LineTo(x*DelkaSirky, (y+1)*DelkaSirky);
      end;
    {ukazatel pro ovladani z klavesnice}
    Canvas.Pen.Width:=0;
    Canvas.Brush.Color:=clGreen;
    Canvas.Ellipse(
      KlavX*DelkaSirky div 2-5,
      KlavY*DelkaSirky div 2-5,
      KlavX*DelkaSirky div 2+5,
      KlavY*DelkaSirky div 2+5)
  end;
end;

procedure TMainForm.PaintBoxMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var sx, sy: byte;  {cislo sirky}
begin
  with PaintBox do
  {vertikalni sirky}
  if Abs(x-(Round(x/DelkaSirky)*DelkaSirky)) <= KlikTolerance then  {nekliknuto uplne mimo}
  begin
    sx:=Round(x/DelkaSirky);
    sy:=Trunc(y/DelkaSirky);
    if (sx=0) or (sx>N) then Exit;
    if (sy=0) or (sy>N-1) then Exit;
    if Vert[sy, sx]<>0 then Exit;
    Vert[sy, sx]:=AktHrac;
    PaintBox.Repaint;
{    Canvas.Pen.Color:=Barvy[AktHrac];
    Canvas.MoveTo(sx*DelkaSirky, sy*DelkaSirky);
    Canvas.LineTo(sx*DelkaSirky, (sy+1)*DelkaSirky);}
    PolozenaSirka(Vertikalne, sy, sx);
    ZmenaHrace;
  end else
  {horizontalni sirky}
  if Abs(y-(Round(y/DelkaSirky)*DelkaSirky)) <= KlikTolerance then  {nekliknuto uplne mimo}
  begin
    sx:=Trunc(x/DelkaSirky);
    sy:=Round(y/DelkaSirky);
    if (sx=0) or (sx>N-1) then Exit;
    if (sy=0) or (sy>N) then Exit;
    if Horiz[sy, sx]<>0 then Exit;
    Horiz[sy, sx]:=AktHrac;
    PaintBox.Repaint;
{    Canvas.Pen.Color:=Barvy[AktHrac];
    Canvas.MoveTo(sx*DelkaSirky, sy*DelkaSirky);
    Canvas.LineTo((sx+1)*DelkaSirky, sy*DelkaSirky);}
    PolozenaSirka(Horizontalne, sy, sx);
    ZmenaHrace;
  end;
end;

procedure TMainForm.ZmenaHrace;
var x, y: Byte;
begin
  AktHrac:=3-AktHrac;
  PlayerBox.Color:=Barvy[AktHrac];
  PlayerBox.Caption:=Player[AktHrac].Jmeno;
  if not Player[AktHrac].Clovek then
  begin
    HintButtonClick(HintButton);
    x:=0;
    y:=0;
    if HintHoriz then x:=x+7 else y:=y+7;
    PaintBoxMouseDown(PaintBox, mbLeft, [], HintX*DelkaSirky+x, HintY*DelkaSirky+y);
    ZmenaHrace;
  end;  
end;

procedure TMainForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of
    VK_LEFT: if KlavX>2 then Dec(KlavX);
    VK_RIGHT: if KlavX<N*2 then Inc(KlavX);
    VK_UP: if KlavY>2 then Dec(KlavY);
    VK_DOWN: if KlavY<N*2 then Inc(KlavY);
    VK_RETURN: begin
      PaintBoxMouseDown(PaintBox, mbLeft, [], KlavX*DelkaSirky div 2, KlavY*DelkaSirky div 2);
    end;
  end;
  PaintBox.Repaint;
end;

procedure TMainForm.PolozenaSirka(hv, sy, sx: Byte);
{zkontroluje, jestli nebyl vytvoren ctverec}
var
  kon: Boolean;
  i, a: Byte;
begin
  HintX:=0;  {zabrani nakresleni hintu (pozdeji pri vykreslovani)}
  with PaintBox do
  case hv of
    {vertiklani sirka}
    Vertikalne: begin
      if (Horiz[sy, sx]=AktHrac) and  {napravo od sirky}
        (Vert[sy, sx+1]=AktHrac) and
        (Horiz[sy+1, sx]=AktHrac) then
      begin
        VertC[sy, sx]:=True;
        HorizC[sy, sx]:=True;
        VertC[sy, sx+1]:=True;
        HorizC[sy+1, sx]:=True;
        case AktHrac of
          1: Hrac1Body.Text:=IntToStr(StrToInt(Hrac1Body.Text)+1);
          2: Hrac2Body.Text:=IntToStr(StrToInt(Hrac1Body.Text)+1);
        end;
        Repaint;
      end;
      if (Horiz[sy, sx-1]=AktHrac) and  {nalevo od sirky}
        (Vert[sy, sx-1]=AktHrac) and
        (Horiz[sy+1, sx-1]=AktHrac) then
      begin
        VertC[sy, sx]:=True;
        HorizC[sy, sx-1]:=True;
        VertC[sy, sx-1]:=True;
        HorizC[sy+1, sx-1]:=True;
        case AktHrac of
          1: Hrac1Body.Text:=IntToStr(StrToInt(Hrac1Body.Text)+1);
          2: Hrac2Body.Text:=IntToStr(StrToInt(Hrac1Body.Text)+1);
        end;
        Repaint;
      end;
    end;
    {horizontalni sirka}
    Horizontalne: begin
      if (Vert[sy, sx]=AktHrac) and  {dolu od sirky}
        (Horiz[sy+1, sx]=AktHrac) and
        (Vert[sy, sx+1]=AktHrac) then
      begin
        HorizC[sy, sx]:=True;
        VertC[sy, sx]:=True;
        HorizC[sy+1, sx]:=True;
        VertC[sy, sx+1]:=True;
        case AktHrac of
          1: Hrac1Body.Text:=IntToStr(StrToInt(Hrac1Body.Text)+1);
          2: Hrac2Body.Text:=IntToStr(StrToInt(Hrac1Body.Text)+1);
        end;
        Repaint;
      end;
      if (Vert[sy-1, sx]=AktHrac) and  {nahoru od sirky}
        (Horiz[sy-1, sx]=AktHrac) and
        (Vert[sy-1, sx+1]=AktHrac) then
      begin
        HorizC[sy, sx]:=True;
        VertC[sy-1, sx]:=True;
        HorizC[sy-1, sx]:=True;
        VertC[sy-1, sx+1]:=True;
        case AktHrac of
          1: Hrac1Body.Text:=IntToStr(StrToInt(Hrac1Body.Text)+1);
          2: Hrac2Body.Text:=IntToStr(StrToInt(Hrac1Body.Text)+1);
        end;   
        Repaint;
      end;
    end;
  end;

  kon:=True;
  {kontrole konce hry}
  {horizontalni sirky}
  for sy:=1 to N do
   for sx:=1 to N-1 do
     if Horiz[sy, sx]=0 then
       kon:=False;
  {vertikalni sirky}
  for sy:=1 to N-1 do
   for sx:=1 to N do
     if Vert[sy, sx]=0 then
       kon:=False;
  if Kon then
  begin
    sx:=StrToInt(Hrac1Body.Text);
    sy:=StrToInt(Hrac2Body.Text);
    if sx=sy then
      ShowMessage('Hra skoncila remizou')
    else if sx<sy then
      ShowMessage('Vyhral modry hrac ' + Player[1].Jmeno)
    else
      ShowMessage('Vyhral cerveny hrac ' + Player[2].Jmeno);
    {pridani do top 1. hrace}
    i:=1;
    repeat
      if StrToInt(Hrac1Body.Text)>StrToInt(TopTenForm.Pozice[i].Body.Caption) then Break;
      Inc(i);
    until i>10;
    if i<=10 then
    begin
      for a:=i to 9 do
      begin
        TopTenForm.Pozice[a+1].Jmeno.Caption:=TopTenForm.Pozice[a].Jmeno.Caption;
        TopTenForm.Pozice[a+1].Body.Caption:=TopTenForm.Pozice[a].Body.Caption;
      end;
      TopTenForm.Pozice[i].Jmeno.Caption:=Player[1].Jmeno;
      TopTenForm.Pozice[i].Body.Caption:=Hrac1Body.Text;
    end;
    {pridani do top 2. hrace}
    i:=1;
    repeat
      if StrToInt(Hrac2Body.Text)>StrToInt(TopTenForm.Pozice[i].Body.Caption) then Break;
      Inc(i);
    until i>10;
    if i<=10 then
    begin
      for a:=i to 9 do
      begin
        TopTenForm.Pozice[a+1].Jmeno.Caption:=TopTenForm.Pozice[a].Jmeno.Caption;
        TopTenForm.Pozice[a+1].Body.Caption:=TopTenForm.Pozice[a].Body.Caption;
      end;
      TopTenForm.Pozice[i].Jmeno.Caption:=Player[2].Jmeno;
      TopTenForm.Pozice[i].Body.Caption:=Hrac2Body.Text;
    end;
    TopTenForm.IniSave;
    StartButtonClick(nil);
  end;
end;

procedure TMainForm.StartButtonClick(Sender: TObject);
var y, x: Byte;
begin
  with StartForm do
  if ShowModal=mrOk then
  begin
    N:=PoleEdit.Value+1;
    Player[1].Jmeno:=Name1.Text;
    Player[1].Clovek:=Type1.ItemIndex=0;
    Player[2].Jmeno:=Name2.Text;
    Player[2].Clovek:=Type2.ItemIndex=0;
    Hrac1Label.Caption:=Name1.Text;
    Hrac2Label.Caption:=Name2.Text;
    KlavX:=2;
    KlavY:=2;
    AktHrac:=2;
    ZmenaHrace;
    Self.Width:=250+(N+1)*DelkaSirky;
    Self.Height:=100+(N+1)*DelkaSirky;
    Self.PaintBox.Width:=(N+1)*DelkaSirky;
    Self.PaintBox.Height:=(N+1)*DelkaSirky;
    if Height<300 then Height:=300;
    for y:=0 to N+1 do
      for x:=0 to N+1 do
      begin
        Horiz[y, x]:=0;
        HorizC[y, x]:=False;
        Vert[y, x]:=0;
        VertC[y, x]:=False;
      end;
    Hrac1Body.Text:='0';
    Hrac2Body.Text:='0';
    PaintBox.Repaint;
  end;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  KeyPreview:=True;
end;

procedure TMainForm.TopTenButtonClick(Sender: TObject);
begin
  TopTenForm.ShowModal;
end;

{function GetBest(Vert,} 

procedure TMainForm.HintButtonClick(Sender: TObject);
var
  sy, sx, p: Byte;
  maxp: record
    p, x, y: Byte;
    horiz: boolean;
  end;
begin
  {zabrani souperovi ve skorovani}
  for sy:=1 to N do
    for sx:=1 to N do
    begin
      {vertikalni}
      if (Vert[sy, sx]=0) and
        (((Horiz[sy, sx]=3-AktHrac) and  {napravo od sirky}
           (Vert[sy, sx+1]=3-AktHrac) and
           (Horiz[sy+1, sx]=3-AktHrac)) or
        ((Horiz[sy, sx-1]=3-AktHrac) and  {nalevo od sirky}
           (Vert[sy, sx-1]=3-AktHrac) and
           (Horiz[sy+1, sx-1]=3-AktHrac))) then
      begin
        HintHoriz:=False;
        HintX:=sx;
        HintY:=sy;
        Repaint;
        Exit;
      end;
      {horizontalni}
      if (Horiz[sy, sx]=0) and
        (((Vert[sy, sx]=3-AktHrac) and  {dolu od sirky}
           (Horiz[sy+1, sx]=3-AktHrac) and
           (Vert[sy, sx+1]=3-AktHrac)) or
        ((Vert[sy-1, sx]=3-AktHrac) and  {nahoru od sirky}
           (Horiz[sy-1, sx]=3-AktHrac) and
           (Vert[sy-1, sx+1]=3-AktHrac))) then
      begin
        HintHoriz:=True;
        HintX:=sx;
        HintY:=sy;
        Repaint;
        Exit;
      end;
    end;
  {pokud se nepotrebuje zabranovat, da sirku tam, kde je nejvic jeho kolem}
  maxp.p:=0;
  for sy:=1 to N do
    for sx:=1 to N do
    begin
      {horizontal}
      p:=0;
      if Vert[sy-1, sx]=AktHrac then Inc(p);
      if Horiz[sx-1, sy]=AktHrac then Inc(p);
      if Vert[sy, sx]=AktHrac then Inc(p);
      if Vert[sy-1, sx+1]=AktHrac then Inc(p);
      if Horiz[sy, sx+1]=AktHrac then Inc(p);
      if Vert[sy, sx+1]=AktHrac then Inc(p);
      if (p>=maxp.p) and (Horiz[sy, sx]=0) and (sx<>N) then
      begin
        maxp.p:=p;
        maxp.x:=sx;
        maxp.y:=sy;
        maxp.horiz:=True;
      end;
      {vertikal}
      p:=0;
      if Horiz[sy, sx]=AktHrac then Inc(p);
      if Vert[sy-1, sx]=AktHrac then Inc(p);
      if Horiz[sy, sx-1]=AktHrac then Inc(p);
      if Horiz[sy+1, sx]=AktHrac then Inc(p);
      if Vert[sy+1, sx]=AktHrac then Inc(p);
      if Horiz[sy, sx-1]=AktHrac then Inc(p);
      if (p>=maxp.p) and (Vert[sy, sx]=0) and (sy<>N) then
      begin
        maxp.p:=p;
        maxp.x:=sx;
        maxp.y:=sy;
        maxp.horiz:=False;
      end;
    end;
  HintX:=maxp.x;
  HintY:=maxp.y;
  HintHoriz:=maxp.horiz;
  Repaint;  
end;


end.
